SystemOrganization addCategory: #QM!

PPCompositeParser subclass: #QMGrammar
	instanceVariableNames: 'title titleStart titleEnd titleBody eqGroup varString quotedString aSpecialChar body qText genElement modelElement documentationElement frameworkElement packageElement classElement statechartElement entryElement exitElement actionElement attributeElement directoryElement fileElement textElement glyphElement initialElement stateElement tranElement choiceElement initialGlyphElement stateGlyphElement tranGlyphElement choiceGlyphElement anyElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QM'!

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/6/2016 17:16'!
aSpecialChar
^ $> asParser / $" asParser  / $< asParser / $= asParser / $? asParser .! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:51'!
actionElement
^  '<action' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</action>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/11/2016 15:34'!
anyElement
^ modelElement / documentationElement / frameworkElement / packageElement / classElement / statechartElement / entryElement / exitElement / actionElement / attributeElement / directoryElement  / fileElement / textElement / initialElement / stateElement / tranElement / choiceElement / glyphElement  trim .! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:51'!
attributeElement
^  '<attribute' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</attribute>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/11/2016 17:24'!
body
^ anyElement  plus .! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:51'!
choiceElement
^  '<choice' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</choice>' asParser trim)) trim .

! !

!QMGrammar methodsFor: 'hasVisualShape' stamp: 'PhilipHunt 4/12/2016 10:51'!
choiceGlyphElement
^  '<choice_glyph' asParser trim , eqGroup star,

('/>' asParser trim  /  ( $> asParser, genElement star, '</choice_glyph>' asParser trim)) trim .






! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:52'!
classElement
^  '<class' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</class>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:52'!
directoryElement
^  '<directory' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</directory>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/11/2016 17:57'!
documentationElement
^  '<documentation' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</documentation>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:52'!
entryElement
^  '<entry' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</entry>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/7/2016 13:43'!
eqGroup
^ varString, $= asParser, quotedString trim .! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:52'!
exitElement
^  '<exit' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</exit>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:52'!
fileElement
^  '<file' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</file>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:52'!
frameworkElement
^  '<framework' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</framework>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/13/2016 09:54'!
genElement
^ (qText / anyElement ).

" (qText optional trim flatten),"  ! !

!QMGrammar methodsFor: 'hasVisualShape' stamp: 'PhilipHunt 4/11/2016 15:11'!
glyphElement
^ ( initialGlyphElement / stateGlyphElement / tranGlyphElement / choiceGlyphElement ) trim .





! !

!QMGrammar methodsFor: 'hasVisualShape' stamp: 'PhilipHunt 4/12/2016 10:52'!
initialElement
^  '<initial' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</initial>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:52'!
initialGlyphElement
^  '<initial_glyph' asParser trim , eqGroup star,

('/>' asParser trim  /  ( $> asParser, genElement star, '</initial_glyph>' asParser trim)) trim .






! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:53'!
modelElement
^  '<model' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</model>' asParser trim)) trim .

" <model eq* />"
" <model eq* >..others..</model> "
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 17:20'!
packageElement
^  '<package' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement , '</package>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 09:53'!
qText
^ '</' asParser negate star flatten trim .! !

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/6/2016 17:13'!
quotedString
^ $" asParser, varString	, $" asParser .! !

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/6/2016 17:27'!
start
^ title, body end .! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 17:28'!
stateElement
^  '<state' asParser trim , eqGroup star,

(
'/>' asParser trim  /  

( $> asParser, genElement, '</state>' asParser trim)

) trim .

! !

!QMGrammar methodsFor: 'hasVisualShape' stamp: 'PhilipHunt 4/12/2016 10:53'!
stateGlyphElement
^  '<state_glyph' asParser trim , eqGroup star,

('/>' asParser trim  /  ( $> asParser, genElement star, '</state_glyph>' asParser trim)) trim .






! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:53'!
statechartElement
^  '<statechart' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</statechart>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:53'!
textElement
^  '<text' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</text>' asParser trim)) trim .
! !

!QMGrammar methodsFor: 'forTitle' stamp: 'PhilipHunt 4/6/2016 17:07'!
title
^ titleStart, titleBody, titleEnd .! !

!QMGrammar methodsFor: 'forTitle' stamp: 'PhilipHunt 4/7/2016 13:39'!
titleBody
^ eqGroup trim plus .! !

!QMGrammar methodsFor: 'forTitle' stamp: 'PhilipHunt 4/7/2016 13:43'!
titleEnd
^ '?>' asParser trim .! !

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 09:59'!
titleStart
^ '<?' asParser trim .! !

!QMGrammar methodsFor: 'topLevel' stamp: 'PhilipHunt 4/12/2016 10:53'!
tranElement
^  '<tran' asParser trim , eqGroup star,

 ('/>' asParser trim  /  ( $> asParser, genElement star, '</tran>' asParser trim)) trim .

! !

!QMGrammar methodsFor: 'hasVisualShape' stamp: 'PhilipHunt 4/12/2016 10:53'!
tranGlyphElement
^  '<tran_glyph' asParser trim , eqGroup star,

('/>' asParser trim  /  ( $> asParser, genElement star, '</tran_glyph>' asParser trim)) trim .






! !

!QMGrammar methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 09:53'!
varString
^  aSpecialChar negate plus flatten trim .! !

PPCompositeParser subclass: #QMGrammar2
	instanceVariableNames: 'title titleStart titleEnd titleBody eqGroup varString quotedString aSpecialChar body qText genElement genStart genEnd attributeElement multiLineElement oneLineElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QM'!

QMGrammar2 subclass: #QMAOPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QM'!

!QMAOPackage methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/18/2016 15:11'!
start
^ body end.! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 10:01'!
aSpecialChar
^ $> asParser / $" asParser  / $< asParser / $= asParser / $? asParser .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/15/2016 15:34'!
attributeElement
Halt . ^ genStart trim , eqGroup star,
( ('/>' asParser trim) /  ( $> asParser, genElement , genEnd trim) ) trim  .

"( ('/>' asParser trim , qText optional) /  ( $> asParser, genElement , genEnd trim) ) trim ."! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 11:25'!
body
^ genElement   .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/18/2016 15:08'!
eqGroup
^ varString, $= asParser, quotedString trim .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/14/2016 13:59'!
genElement
"^ (qText / attributeElement) ."
^ (  multiLineElement / oneLineElement / qText)  min: 0 max: 15  .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/14/2016 14:59'!
genEnd
^ '</' asParser, (#letter asParser / $_ asParser) plus flatten trim, $> asParser  trim .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/14/2016 14:59'!
genStart
^ $< asParser, ((#letter asParser / $_ asParser)   plus flatten ) trim.! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/15/2016 16:35'!
multiLineElement
^ ( genStart trim , eqGroup star, $> asParser, genElement , genEnd trim ) trim .
"==> [:tok | tok second second third second]."
! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 14:19'!
oneLineElement
^  genStart trim , eqGroup star, '/>' asParser trim .
! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 11:47'!
qText
^ $< asParser negate star flatten trim .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 10:02'!
quotedString
^ $" asParser, varString	, $" asParser .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 11:10'!
start
^ title , body end .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 09:58'!
title
^ titleStart, titleBody, titleEnd .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 10:00'!
titleBody
^ eqGroup trim plus .! !

!QMGrammar2 methodsFor: 'forTitle' stamp: 'PhilipHunt 4/13/2016 10:00'!
titleEnd
^ '?>' asParser trim .! !

!QMGrammar2 methodsFor: 'forTitle' stamp: 'PhilipHunt 4/13/2016 09:59'!
titleStart
^ '<?' asParser trim .! !

!QMGrammar2 methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 4/13/2016 10:01'!
varString
^  aSpecialChar negate plus flatten trim .! !
